import java.util.Random;
import java.awt.Dimension;
import daj.*;

public class MainApp extends daj.Application {
  public static final Dimension SIZE = new Dimension (450, 450);
  public static final int nrOfProgs = 4;
  public daj.Node[] nodes;
  public AProg[] progs;

  // Constructor
  public MainApp () {
    super ("Li and Hudak's path compression", SIZE.width, SIZE.height);
    nodes = new daj.Node[nrOfProgs];
    progs = new AProg[nrOfProgs];
  }

  public void construct() {
    int i,j;
    Random rand = new Random();
    // create all nodes
    for (i=0; i<nrOfProgs; i++) {
      nodes[i] = node(progs[i]=new AProg(i, (i+1), i==(nrOfProgs-1)), String.valueOf(i), 160*(i%2)+80, 160*(i/2)+80);
    }
    // link all Nodes
    for (i=0; i<nrOfProgs; i++) {
      for (j=0; j<nrOfProgs; j++) {
        link(nodes[i], nodes[j]);
      }
    }
  }


  public String getText () {
    return "Li and Hudak's path compression";
  }


  public static void main (String[] args) {
    new MainApp().run ();
  }

}